Bug 269541 - Processes hang and system is unrebootable after snapshot invalidation
Processes hang and system is unrebootable after snapshot invalidation
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
x86_64 Linux
medium Severity high
: ---
: ---
Assigned To: Kernel Maintainer List
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2007-08-30 17:31 EDT by Philip Spencer
Modified: 2007-11-30 17:12 EST (History)
0 users

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2007-09-25 18:30:23 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Philip Spencer 2007-08-30 17:31:23 EDT
Description of problem:

When a snapshot is taken of a logical volume and the snapshot fills up and
has to be invalidated, the process writing to the original volume hangs in an
unkillable wait state. Also, any subsequent processes that query the filesystem
tree hang as well. This includes any attempt to run "reboot" or "shutdown",
meaning the system has to be hard-power-cycled to restore it.

This is fixed upstream and seems to be fixed in the current development kernel
(2.6.23-0.42.rc3.git10.fc8) but that kernel is unusable on a Fedora Core 6
machine (requires a newer mkinitrd that segfaults if run on FC6, and has
numerous other dependency problems). So it would be nice to have an FC6 errata
issued, given that being hit by this bug requires a hard reset to restore normal

Version-Release number of selected component (if applicable):


How reproducible:

100% reproducible

Steps to Reproduce:
1. lvcreate -L 512M -n testlv vg1 [where vg1=name of a volume group with
     sufficient space)
2. mkfs /dev/vg1/testlv; mkdir /testmnt; mount /dev/vg1/testlv /testmnt
3. lvcreate -s -n testsnap -L 128M /dev/vg1/testlv
4. head -c 200m /dev/zero > /testmnt/largefile  

Actual results:

"Invalidating snapshot" is logged to syslog (as expected).
The "head" process hangs in an unkillable wait state.
Any subsequent process that tries to access low-level filesystem tables also
hangs unkillably. This includes "reboot" and "shutdown".

Expected results:

"Invalidating snapshot" is logged.
The "head" process continues and finishes as normal. 
Other processes all behave as normal as well, except that any attempt to
mount the snapshot or read data from it should give an I/O error.

Additional info:

Fixed in 2.6.23-0.42.rc3.git10.fc8 but that kernel as packaged can't be
installed on an FC6 system.
Comment 1 Chuck Ebbert 2007-08-31 14:39:01 EDT
Patch found, will be in upcoming kernel (but not the next one that's already
submitted for updates-testing.)
Comment 2 Chuck Ebbert 2007-09-14 15:00:17 EDT
In kernel-, submitted for testing.

Note You need to log in before you can comment on or make changes to this bug.